<?php

namespace Modules\Target\Requests\Employee;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\Target\Enums\TargetLengthEnum;
use Modules\User\Enums\UserRoleEnum;

class FetchTargetRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = UserRoleEnum::employees();
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('tags'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $statuses = TargetLengthEnum::values();
        $rules =
        [
            'product_id'=>
            [
                'required',
                'array'
            ],
            'product_id.*'=>
            [
                Rule::exists('products','id')->whereNull('deleted_at')
            ],
            'year'=>
            [
                'required',
                'digits:4',
                'integer',
                'between:1900,2100'
            ],
            'length'=>
            [
                'required',
                'array'
            ],
            'length.*'=>
            [
                'in:'.implode(',',$statuses)
            ],
            'employee_id'=>
            [
                'required'=>
                Rule::exists('users','id')->whereNull('deleted_at')
            ]
        ];

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [];
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
